## quaternion 0.0.5

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)

project(quaternion CXX)

if(UNIX AND NOT APPLE)
    set(LINUX 1)
endif(UNIX AND NOT APPLE)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
    include(cmake/ECMInstallIcons.cmake)
endif(NOT WIN32)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

# Setup command line parameters for the compiler and linker
CHECK_CXX_COMPILER_FLAG("-Wall" WALL_FLAG_SUPPORTED)
if ( WALL_FLAG_SUPPORTED )
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif ( WALL_FLAG_SUPPORTED )

if ( CMAKE_VERSION VERSION_LESS "3.1" )
    CHECK_CXX_COMPILER_FLAG("-std=c++11" STD_FLAG_SUPPORTED)
    if ( STD_FLAG_SUPPORTED )
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    endif ( STD_FLAG_SUPPORTED )
else ( CMAKE_VERSION VERSION_LESS "3.1" )
    set(CMAKE_CXX_STANDARD 11)
endif ( CMAKE_VERSION VERSION_LESS "3.1" )

# Find the libraries
find_package(Qt5 5.2.1 REQUIRED Widgets Network Quick Qml Gui)
get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)

message( STATUS )
message( STATUS "=============================================================================" )
message( STATUS "                          Quaternion Build Information" )
message( STATUS "=============================================================================" )
if (CMAKE_BUILD_TYPE)
    message( STATUS "Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
message( STATUS "Quaternion install prefix: ${CMAKE_INSTALL_PREFIX}" )
message( STATUS "=============================================================================" )
message( STATUS )

add_subdirectory(lib)
include_directories(lib)

# Set up source files
set(quaternion_SRCS
    client/quaternionroom.cpp
    client/message.cpp
    client/imageprovider.cpp
    client/activitydetector.cpp
    client/logindialog.cpp
    client/mainwindow.cpp
    client/roomlistdock.cpp
    client/userlistdock.cpp
    client/kchatedit.cpp
    client/chatedit.cpp
    client/chatroomwidget.cpp
    client/systemtray.cpp
    client/models/messageeventmodel.cpp
    client/models/userlistmodel.cpp
    client/models/roomlistmodel.cpp
    client/main.cpp
    )

set(quaternion_QRC
    client/resources.qrc
    )

QT5_ADD_RESOURCES(quaternion_QRC_SRC ${quaternion_QRC})

# Tell CMake to create the executable
# (and that on Windows it should be a GUI executable)
# TODO: MacOS builders, should MACOSX_BUNDLE be specified here as well?
add_executable(quaternion WIN32 ${quaternion_SRCS} ${quaternion_QRC_SRC})

target_link_libraries(quaternion qmatrixclient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)

# Installation

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR ".")
endif()

install(TARGETS quaternion
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
if(LINUX)
    install(FILES linux/quaternion.desktop
            DESTINATION  ${CMAKE_INSTALL_DATADIR}/applications
            )
    install(FILES linux/com.github.quaternion.appdata.xml
            DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
            )
    file(GLOB quaternion_icons icons/quaternion/*-apps-quaternion.png)
    ecm_install_icons(ICONS ${quaternion_icons} icons/quaternion/sc-apps-quaternion.svgz
                      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
                      )
endif(LINUX)

if(WIN32)
    if (${Qt5_VERSION} VERSION_LESS "5.3")
        install(CODE "
            message(\"Deploying on Windows is only supported with Qt 5.3 or higher\")
            message(\"Bare executable has been copied to the target folder\")
        ")
    else()
        get_filename_component(Qt5_WinBaseDir "${Qt5_DIR}/../../.." ABSOLUTE)
        install(CODE "
            if (CMAKE_INSTALL_CONFIG_NAME STREQUAL \"Debug\")
                set(WDQ_FLAG debug)
            else()
                set(WDQ_FLAG release)
            endif()
            execute_process(
                COMMAND bin/windeployqt --\${WDQ_FLAG} --no-system-d3d-compiler --no-opengl
                    --no-multimedia --no-multimediaquick --no-declarative --no-test \
                    --qmldir qml \"\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}\"
                WORKING_DIRECTORY \"${Qt5_WinBaseDir}\"
                RESULT_VARIABLE WDQ_RETVAL
            )
            if (WDQ_RETVAL)
                message( \"windeployqt returned \${WDQ_RETVAL} - check messages above\")
            else()
                message( STATUS \"Quaternion and its dependencies have been deployed to \${CMAKE_INSTALL_PREFIX}.\")
            endif()
        ")
    endif()
endif(WIN32)

=== debian/changelog ===
quaternion (0.0.5-1) unstable; urgency=medium

  * New upstream release
  * Updated copyright file

 -- Hubert Chathi <uhoreg@debian.org>  Sat, 23 Dec 2017 08:33:05 -0500

quaternion (0.0.1+git20170607.121b251-1) unstable; urgency=medium

  * Initial release (Closes: #864375)

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 30 Aug 2017 08:48:48 -0400

=== debian/control ===
Source: quaternion
Section: net
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Build-Depends: debhelper (>=9), cmake, qtbase5-dev (>= 5.2.1), qtdeclarative5-dev
Standards-Version: 3.9.8
Homepage: https://github.com/QMatrixClient/Quaternion
Vcs-Git: git://anonscm.debian.org/collab-maint/quaternion.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/quaternion.git

Package: quaternion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: desktop IM client for the Matrix protocol
 Quaternion is a Qt-based chat client for the Matrix protocol.  Matrix is an
 open, federated communications protocol.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ 


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
make-orig-source:
	tar czf ../quaternion_$(VERSION).orig.tar.gz --exclude-vcs --exclude-backups --exclude /debian --exclude /lib -C .. `basename $(CURDIR)`
	tar czf ../quaternion_$(VERSION).orig-lib.tar.gz --exclude-vcs --exclude-backups lib

## quaternion 0.0.9.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(qmatrixclient CXX)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
endif(NOT WIN32)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
    set(CMAKE_INSTALL_LIBDIR ".")
endif()

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR ".")
endif()

if (NOT CMAKE_INSTALL_INCLUDEDIR)
    set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

set(CMAKE_CXX_STANDARD 14)

foreach (FLAG all "" pedantic extra error=return-type no-unused-parameter no-gnu-zero-variadic-macro-arguments)
    CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
    if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W${FLAG}")
    endif ()
endforeach ()

find_package(Qt5 5.4.1 REQUIRED Network Gui)
get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)

if (GTAD_PATH)
    get_filename_component(ABS_GTAD_PATH "${GTAD_PATH}" ABSOLUTE)
endif ()
if (MATRIX_DOC_PATH)
    get_filename_component(ABS_API_DEF_PATH "${MATRIX_DOC_PATH}/api/client-server" ABSOLUTE)
endif ()

message( STATUS )
message( STATUS "=============================================================================" )
message( STATUS "                       libqmatrixclient Build Information" )
message( STATUS "=============================================================================" )
if (CMAKE_BUILD_TYPE)
    message( STATUS "Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
if (MATRIX_DOC_PATH AND GTAD_PATH)
    message( STATUS "Generating API stubs enabled" )
    message( STATUS "  Using GTAD at ${ABS_GTAD_PATH}" )
    message( STATUS "  Using CS API files at ${ABS_API_DEF_PATH}" )
endif ()
message( STATUS "=============================================================================" )
message( STATUS )

# Set up source files
set(libqmatrixclient_SRCS
    lib/networkaccessmanager.cpp
    lib/connectiondata.cpp
    lib/connection.cpp
    lib/logging.cpp
    lib/room.cpp
    lib/user.cpp
    lib/avatar.cpp
    lib/settings.cpp
    lib/networksettings.cpp
    lib/converters.cpp
    lib/util.cpp
    lib/events/event.cpp
    lib/events/eventcontent.cpp
    lib/events/roommessageevent.cpp
    lib/events/roommemberevent.cpp
    lib/events/roomavatarevent.cpp
    lib/events/typingevent.cpp
    lib/events/receiptevent.cpp
    lib/events/directchatevent.cpp
    lib/jobs/requestdata.cpp
    lib/jobs/basejob.cpp
    lib/jobs/sendeventjob.cpp
    lib/jobs/syncjob.cpp
    lib/jobs/mediathumbnailjob.cpp
    lib/jobs/downloadfilejob.cpp
)

set(CSAPI_DIR csapi)
set(FULL_CSAPI_DIR lib/${CSAPI_DIR})
if (MATRIX_DOC_PATH AND GTAD_PATH)
    file(GLOB_RECURSE API_DEFS RELATIVE ${PROJECT_SOURCE_DIR}
        ${ABS_API_DEF_PATH}/*.yaml
        ${ABS_API_DEF_PATH}/definitions/*.yaml
        ${MATRIX_DOC_PATH}/event-schemas/schema/*
    )
    add_custom_target(update-api
        ${ABS_GTAD_PATH} --config ${CSAPI_DIR}/gtad.yaml --out ${CSAPI_DIR}
            ${ABS_API_DEF_PATH}
            cas_login_redirect.yaml- cas_login_ticket.yaml-
            old_sync.yaml- room_initial_sync.yaml- # deprecated
            sync.yaml-
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/lib
        SOURCES ${FULL_CSAPI_DIR}/gtad.yaml
                ${FULL_CSAPI_DIR}/{{base}}.h.mustache
                ${FULL_CSAPI_DIR}/{{base}}.cpp.mustache
                ${API_DEFS}
        VERBATIM
    )
endif()

aux_source_directory(${FULL_CSAPI_DIR} libqmatrixclient_job_SRCS)
aux_source_directory(${FULL_CSAPI_DIR}/definitions libqmatrixclient_def_SRCS)

set(example_SRCS examples/qmc-example.cpp)

add_library(QMatrixClient ${libqmatrixclient_SRCS}
            ${libqmatrixclient_job_SRCS} ${libqmatrixclient_def_SRCS})
set(API_VERSION "0.3")
set_property(TARGET QMatrixClient PROPERTY VERSION "${API_VERSION}.0")
set_property(TARGET QMatrixClient PROPERTY SOVERSION 0 )
set_property(TARGET QMatrixClient PROPERTY
             INTERFACE_QMatrixClient_MAJOR_VERSION ${API_VERSION})
set_property(TARGET QMatrixClient APPEND PROPERTY
             COMPATIBLE_INTERFACE_STRING QMatrixClient_MAJOR_VERSION)

target_include_directories(QMatrixClient PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
target_link_libraries(QMatrixClient Qt5::Core Qt5::Network Qt5::Gui)

add_executable(qmc-example ${example_SRCS})
target_link_libraries(qmc-example Qt5::Core QMatrixClient)

# Installation

install(TARGETS QMatrixClient EXPORT QMatrixClientTargets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
install(DIRECTORY lib/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.h")

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/QMatrixClient/QMatrixClientConfigVersion.cmake"
    VERSION ${API_VERSION}
    COMPATIBILITY AnyNewerVersion
)

export(PACKAGE QMatrixClient)
export(EXPORT QMatrixClientTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/QMatrixClient/QMatrixClientTargets.cmake")
configure_file(cmake/QMatrixClientConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/QMatrixClient/QMatrixClientConfig.cmake"
    COPYONLY
)

set(ConfigFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/QMatrixClient")
install(EXPORT QMatrixClientTargets
        FILE QMatrixClientTargets.cmake DESTINATION ${ConfigFilesLocation})

install(FILES cmake/QMatrixClientConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/QMatrixClient/QMatrixClientConfigVersion.cmake"
    DESTINATION ${ConfigFilesLocation}
)
# Only available from CMake 3.7; reserved for future use
#install(EXPORT_ANDROID_MK QMatrixClientTargets DESTINATION share/ndk-modules)

if (WIN32)
    install(FILES mime/packages/freedesktop.org.xml DESTINATION mime/packages)
endif (WIN32)

install(TARGETS qmc-example RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
quaternion (0.0.9.2-1) unstable; urgency=medium

  * New upstream release.

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 09 Jul 2018 10:56:40 -0400

quaternion (0.0.9.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/rules: don't install dev files. (Closes: #898376)
  * debian/control: set maintainer to team.

 -- Hubert Chathi <uhoreg@debian.org>  Wed, 16 May 2018 00:10:17 -0400

quaternion (0.0.9-1) unstable; urgency=medium

  * New upstream release

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 03 May 2018 13:43:06 -0400

quaternion (0.0.5-2) unstable; urgency=medium

  * debian/control:
    * depend on qtquick controls (Closes: #896093)
    * update vcs fields to point to the right location

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 24 Apr 2018 11:12:56 -0400

=== debian/control ===
Source: quaternion
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>
Build-Depends: debhelper (>=9), cmake, qtbase5-dev (>= 5.2.1), qtdeclarative5-dev
Standards-Version: 3.9.8
Homepage: https://github.com/QMatrixClient/Quaternion
Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
Vcs-Browser: https://salsa.debian.org/matrix-team/quaternion.git

Package: quaternion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml-module-qtquick-controls
Description: desktop IM client for the Matrix protocol
 Quaternion is a Qt-based chat client for the Matrix protocol.  Matrix is an
 open, federated communications protocol.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# remove development files
	rm -rf $(CURDIR)/debian/quaternion/usr/include $(CURDIR)/debian/quaternion/usr/lib $(CURDIR)/debian/quaternion/usr/bin/qmc-example

make-orig-source: VERSION = `dpkg-parsechangelog | grep ^Version | sed 's/Version: \(.*\)-[^-]*/\1/'`
make-orig-source:
	tar czf ../quaternion_$(VERSION).orig.tar.gz --exclude-vcs --exclude-backups --exclude /debian --exclude /lib -C .. `basename $(CURDIR)`
	tar czf ../quaternion_$(VERSION).orig-lib.tar.gz --exclude-vcs --exclude-backups lib

## quaternion 0.0.9.3

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

project(quaternion CXX)

if(UNIX AND NOT APPLE)
    set(LINUX 1)
endif(UNIX AND NOT APPLE)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
    include(cmake/ECMInstallIcons.cmake)
endif(NOT WIN32)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

set(CMAKE_CXX_STANDARD 14)

# Setup command line parameters for the compiler and linker
foreach (FLAG "" all pedantic extra no-unused-parameter)
    CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
    if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W${FLAG}")
    endif ()
endforeach ()

# Find the libraries
find_package(Qt5 5.6 REQUIRED Widgets Network Quick Qml QuickWidgets Gui LinguistTools)
if (USE_QQUICKWIDGET)
    find_package(Qt5 5.6 REQUIRED QuickWidgets)
endif()
get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)

if(WIN32)
    enable_language(RC)
    include(CMakeDetermineRCCompiler)

    if(MINGW)
        set(CMAKE_RC_COMPILER_INIT windres)
        set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -I${CMAKE_CURRENT_BINARY_DIR} -i <SOURCE> -o <OBJECT>")
    endif()
endif()

if (USE_INTREE_LIBQMC)
    add_subdirectory(lib EXCLUDE_FROM_ALL)
    include_directories(lib)
else ()
    find_package(QMatrixClient 0.4 REQUIRED)
    if (NOT QMatrixClient_FOUND)
        message( WARNING "libQMatrixClient not found; configuration will most likely fail.")
        message( WARNING "Make sure you have installed libQMatrixClient development files")
        message( WARNING "or pass -DUSE_INTREE_LIBQMC to CMake if you're using the library")
        message( WARNING "as a Git submodule in lib/. See also BUILDING.md")
    endif ()
endif ()

message( STATUS )
message( STATUS "=============================================================================" )
message( STATUS "                          Quaternion Build Information" )
message( STATUS "=============================================================================" )
if (CMAKE_BUILD_TYPE)
    message( STATUS "Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "Quaternion install prefix: ${CMAKE_INSTALL_PREFIX}" )
# Get Git info if possible
find_package(Git)
if(GIT_FOUND)
    execute_process(COMMAND
        "${GIT_EXECUTABLE}" rev-parse -q HEAD
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        OUTPUT_VARIABLE GIT_SHA1
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    message( STATUS "Git SHA1: ${GIT_SHA1}")
endif()
message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
if (USE_INTREE_LIBQMC)
    message( STATUS "Using in-tree libQMatrixClient")
    if (GIT_FOUND)
        execute_process(COMMAND
            "${GIT_EXECUTABLE}" rev-parse -q HEAD
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/lib
            OUTPUT_VARIABLE LIB_GIT_SHA1
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        message( STATUS "  Library git SHA1: ${LIB_GIT_SHA1}")
    endif (GIT_FOUND)
else ()
    message( STATUS "Using libQMatrixClient ${QMatrixClient_VERSION} at ${QMatrixClient_DIR}")
endif ()
if (USE_QQUICKWIDGET)
    message( STATUS "Using QQuickWidget to render QML")
endif(USE_QQUICKWIDGET)
message( STATUS "=============================================================================" )
message( STATUS )

# Set up source files
set(quaternion_SRCS
    client/quaternionroom.cpp
    client/imageprovider.cpp
    client/activitydetector.cpp
    client/dialog.cpp
    client/logindialog.cpp
    client/networkconfigdialog.cpp
    client/roomdialogs.cpp
    client/mainwindow.cpp
    client/roomlistdock.cpp
    client/userlistdock.cpp
    client/kchatedit.cpp
    client/chatedit.cpp
    client/chatroomwidget.cpp
    client/systemtrayicon.cpp
    client/models/messageeventmodel.cpp
    client/models/userlistmodel.cpp
    client/models/roomlistmodel.cpp
    client/main.cpp
    )

set(quaternion_QRC
    client/resources.qrc
    )

set(quaternion_TS
    client/translations/quaternion_en.ts
    client/translations/quaternion_de_DE.ts
    )

QT5_ADD_RESOURCES(quaternion_QRC_SRC ${quaternion_QRC})
set_property(SOURCE qrc_resources.cpp PROPERTY SKIP_AUTOMOC ON)

QT5_ADD_TRANSLATION(quaternion_QM ${quaternion_TS})
QT5_CREATE_TRANSLATION(client/translations ${quaternion_SRCS} ${quaternion_QRC} ${quaternion_TS})

if(WIN32)
    set(quaternion_WINRC ${CMAKE_CURRENT_SOURCE_DIR}/quaternion_win32.rc)
    set_property(SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/quaternion_win32.rc
        APPEND PROPERTY OBJECT_DEPENDS
            ${CMAKE_CURRENT_SOURCE_DIR}/icons/quaternion.ico
    )
endif()

# Windows, this is a GUI executable; OSX, make a bundle
add_executable(quaternion WIN32 MACOSX_BUNDLE ${quaternion_SRCS} ${quaternion_QRC_SRC} ${quaternion_WINRC} ${quaternion_QM})

target_link_libraries(quaternion QMatrixClient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)
target_compile_definitions(quaternion PRIVATE GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")

if (USE_QQUICKWIDGET)
    target_compile_definitions(quaternion PRIVATE USE_QQUICKWIDGET)
    target_link_libraries(quaternion Qt5::QuickWidgets)
endif()

# macOS specific config for bundling
set_target_properties(quaternion PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in")

# Installation

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR ".")
endif()

install(TARGETS quaternion
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})
if(LINUX)
    install(FILES linux/quaternion.desktop
            DESTINATION  ${CMAKE_INSTALL_DATADIR}/applications
            )
    install(FILES linux/com.github.quaternion.appdata.xml
            DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
            )
    install(FILES ${quaternion_QM}
            DESTINATION ${CMAKE_INSTALL_DATADIR}/QMatrixClient/quaternion/translations
            )
    file(GLOB quaternion_icons icons/quaternion/*-apps-quaternion.png)
    ecm_install_icons(ICONS ${quaternion_icons} icons/quaternion/sc-apps-quaternion.svgz
                      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
                      )
endif(LINUX)

if(WIN32)
    if (${Qt5_VERSION} VERSION_LESS "5.3")
        install(CODE "
            message(\"Deploying on Windows is only supported with Qt 5.3 or higher\")
            message(\"Bare executable has been copied to the target folder\")
        ")
    else()
        get_filename_component(Qt5_WinBaseDir "${Qt5_DIR}/../../.." ABSOLUTE)
        install(CODE "
            if (CMAKE_INSTALL_CONFIG_NAME STREQUAL \"Debug\")
                set(WDQ_FLAG debug)
            else()
                set(WDQ_FLAG release)
            endif()
            execute_process(
                COMMAND bin/windeployqt --\${WDQ_FLAG} --no-system-d3d-compiler --no-opengl
                    --no-multimedia --no-multimediaquick --no-declarative --no-test \
                    --qmldir qml \"\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}\"
                WORKING_DIRECTORY \"${Qt5_WinBaseDir}\"
                RESULT_VARIABLE WDQ_RETVAL
            )
            if (WDQ_RETVAL)
                message( \"windeployqt returned \${WDQ_RETVAL} - check messages above\")
            else()
                message( STATUS \"Quaternion and its dependencies have been deployed to \${CMAKE_INSTALL_PREFIX}.\")
            endif()
        ")
        install(FILES ${quaternion_QM}
                DESTINATION ${CMAKE_INSTALL_BINDIR}/translations
               )
    endif()
endif(WIN32)

=== debian/changelog ===
quaternion (0.0.9.3-1) unstable; urgency=medium

  * New upstream release (Closes: #913717).
  * debian/control: depend on libqmatrixclient-dev and qttools5-dev.
  * debian/rules: remove unnecessary rules
  * debian/README.source: remove, since libqmatrixclient is no longer bundled.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 01 Jan 2019 10:34:02 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,12 @@
 Priority: optional
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>
-Build-Depends: debhelper (>=9), cmake, qtbase5-dev (>= 5.2.1), qtdeclarative5-dev
+Build-Depends: cmake
+ , debhelper (>=9)
+ , libqmatrixclient-dev (>= 0.4.0)
+ , qtbase5-dev (>= 5.2.1)
+ , qtdeclarative5-dev
+ , qttools5-dev
 Standards-Version: 3.9.8
 Homepage: https://github.com/QMatrixClient/Quaternion
 Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/QMatrixClient/Quaternion/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## quaternion 0.0.9.4c

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
 
-project(quaternion CXX)
+set(IDENTIFIER "com.github.quaternion")
+set(COPYRIGHT "Copyright © 2018-2019 QMatrixClient Project")
+
+project(quaternion VERSION 0.0.9.4 LANGUAGES CXX)
 
 if(UNIX AND NOT APPLE)
     set(LINUX 1)
@@ -37,11 +40,25 @@
 endforeach ()
 
 # Find the libraries
-find_package(Qt5 5.6 REQUIRED Widgets Network Quick Qml QuickWidgets Gui LinguistTools)
+find_package(Qt5 5.7 REQUIRED Widgets Network Quick Qml Gui LinguistTools Multimedia DBus)
+# Qt5_Prefix is only used to show Qt path in message()
+# Qt5_BinDir is where all the binary tools for Qt are
+if (QT_QMAKE_EXECUTABLE)
+    get_filename_component(Qt5_BinDir "${QT_QMAKE_EXECUTABLE}" DIRECTORY)
+    get_filename_component(Qt5_Prefix "${Qt5_BinDir}/.." ABSOLUTE)
+else()
+    get_filename_component(Qt5_BinDir "${Qt5_DIR}/../../../bin" ABSOLUTE)
+    get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
+endif()
 if (USE_QQUICKWIDGET)
-    find_package(Qt5 5.6 REQUIRED QuickWidgets)
-endif()
-get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
+    find_package(Qt5 5.7 REQUIRED QuickWidgets)
+elseif(NOT DISABLE_QQUICKWIDGET)
+    # QQuickWidget only stopped crashing in Qt 5.12, use it by default if found
+    find_package(Qt5 5.12 QUIET COMPONENTS QuickWidgets)
+    if (Qt5QuickWidgets_FOUND)
+        set(USE_QQUICKWIDGET ON)
+    endif()
+endif()
 
 if(WIN32)
     enable_language(RC)
@@ -53,18 +70,28 @@
     endif()
 endif()
 
-if (USE_INTREE_LIBQMC)
+if ((NOT DEFINED USE_INTREE_LIBQMC OR USE_INTREE_LIBQMC)
+        AND EXISTS ${PROJECT_SOURCE_DIR}/lib/lib/util.h)
     add_subdirectory(lib EXCLUDE_FROM_ALL)
     include_directories(lib)
-else ()
-    find_package(QMatrixClient 0.4 REQUIRED)
+    if (NOT DEFINED USE_INTREE_LIBQMC)
+        set (USE_INTREE_LIBQMC 1)
+    endif ()
+endif ()
+if (NOT USE_INTREE_LIBQMC)
+    find_package(QMatrixClient 0.5.1 REQUIRED)
     if (NOT QMatrixClient_FOUND)
         message( WARNING "libQMatrixClient not found; configuration will most likely fail.")
         message( WARNING "Make sure you have installed libQMatrixClient development files")
-        message( WARNING "or pass -DUSE_INTREE_LIBQMC to CMake if you're using the library")
-        message( WARNING "as a Git submodule in lib/. See also BUILDING.md")
+        message( WARNING "as a package or checked out the library sources in lib/.")
+        message( WARNING "See also BUILDING.md")
     endif ()
 endif ()
+
+find_package(Qt5Keychain QUIET)
+if (Qt5Keychain_FOUND)
+    set(USE_KEYCHAIN ON)
+endif()
 
 message( STATUS )
 message( STATUS "=============================================================================" )
@@ -102,6 +129,9 @@
 if (USE_QQUICKWIDGET)
     message( STATUS "Using QQuickWidget to render QML")
 endif(USE_QQUICKWIDGET)
+if (USE_KEYCHAIN)
+    message( STATUS "Using Qt5Keychain ${Qt5Keychain_VERSION} at ${Qt5Keychain_DIR}")
+endif ()
 message( STATUS "=============================================================================" )
 message( STATUS )
 
@@ -124,6 +154,8 @@
     client/models/messageeventmodel.cpp
     client/models/userlistmodel.cpp
     client/models/roomlistmodel.cpp
+    client/models/abstractroomordering.cpp
+    client/models/orderbytag.cpp
     client/main.cpp
     )
 
@@ -131,38 +163,71 @@
     client/resources.qrc
     )
 
+# quaternion_en.ts is updated explicitly by building trbase target,
+# while all other translation files are created and updated externally at
+# Lokalise.co
+set(quaternion_en_TS client/translations/quaternion_en.ts)
+QT5_CREATE_TRANSLATION(client/translations ${quaternion_SRCS} ${quaternion_QRC} ${quaternion_en_TS})
+add_custom_target(trbase SOURCES ${quaternion_en_TS} VERBATIM)
+
 set(quaternion_TS
-    client/translations/quaternion_en.ts
+    client/translations/quaternion_en_GB.ts
     client/translations/quaternion_de_DE.ts
-    )
+    client/translations/quaternion_pl.ts
+    client/translations/quaternion_ru.ts
+    )
+QT5_ADD_TRANSLATION(quaternion_QM ${quaternion_TS})
 
 QT5_ADD_RESOURCES(quaternion_QRC_SRC ${quaternion_QRC})
 set_property(SOURCE qrc_resources.cpp PROPERTY SKIP_AUTOMOC ON)
 
-QT5_ADD_TRANSLATION(quaternion_QM ${quaternion_TS})
-QT5_CREATE_TRANSLATION(client/translations ${quaternion_SRCS} ${quaternion_QRC} ${quaternion_TS})
-
 if(WIN32)
-    set(quaternion_WINRC ${CMAKE_CURRENT_SOURCE_DIR}/quaternion_win32.rc)
-    set_property(SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/quaternion_win32.rc
-        APPEND PROPERTY OBJECT_DEPENDS
-            ${CMAKE_CURRENT_SOURCE_DIR}/icons/quaternion.ico
-    )
-endif()
+    set(quaternion_WINRC quaternion_win32.rc)
+    set_property(SOURCE quaternion_win32.rc APPEND PROPERTY
+        OBJECT_DEPENDS ${PROJECT_SOURCE_DIR}/icons/quaternion.ico
+    )
+endif()
+
+if(APPLE)
+    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
+    set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
+
+    set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
+
+    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${quaternion_VERSION})
+    set(MACOSX_BUNDLE_BUNDLE_VERSION ${quaternion_VERSION})
+
+    set(ICON_NAME "quaternion.icns")
+    set(${PROJECT_NAME}_MAC_ICON "${PROJECT_SOURCE_DIR}/icons/${ICON_NAME}")
+    set(MACOSX_BUNDLE_ICON_FILE ${ICON_NAME})
+    set_property(SOURCE "${${PROJECT_NAME}_MAC_ICON}" PROPERTY
+        MACOSX_PACKAGE_LOCATION Resources)
+endif(APPLE)
 
 # Windows, this is a GUI executable; OSX, make a bundle
-add_executable(quaternion WIN32 MACOSX_BUNDLE ${quaternion_SRCS} ${quaternion_QRC_SRC} ${quaternion_WINRC} ${quaternion_QM})
-
-target_link_libraries(quaternion QMatrixClient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)
-target_compile_definitions(quaternion PRIVATE GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")
+add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE
+    ${quaternion_SRCS} ${quaternion_QRC_SRC} ${quaternion_QM}
+    ${quaternion_WINRC} ${${PROJECT_NAME}_MAC_ICON})
+
+target_link_libraries(${PROJECT_NAME}
+    QMatrixClient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)
+target_compile_definitions(${PROJECT_NAME} PRIVATE
+    GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")
 
 if (USE_QQUICKWIDGET)
-    target_compile_definitions(quaternion PRIVATE USE_QQUICKWIDGET)
-    target_link_libraries(quaternion Qt5::QuickWidgets)
+    target_compile_definitions(${PROJECT_NAME} PRIVATE USE_QQUICKWIDGET)
+    target_link_libraries(${PROJECT_NAME} Qt5::QuickWidgets)
+endif()
+
+if(USE_KEYCHAIN)
+    target_compile_definitions(${PROJECT_NAME} PRIVATE USE_KEYCHAIN)
+    target_link_libraries(${PROJECT_NAME} ${QTKEYCHAIN_LIBRARIES})
+    include_directories(${QTKEYCHAIN_INCLUDE_DIR})
 endif()
 
 # macOS specific config for bundling
-set_target_properties(quaternion PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in")
+set_property(TARGET ${PROJECT_NAME} PROPERTY
+    MACOSX_BUNDLE_INFO_PLIST "${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in")
 
 # Installation
 
@@ -170,14 +235,14 @@
     set(CMAKE_INSTALL_BINDIR ".")
 endif()
 
-install(TARGETS quaternion
+install(TARGETS ${PROJECT_NAME}
         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
         BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})
 if(LINUX)
-    install(FILES linux/quaternion.desktop
+    install(FILES linux/${IDENTIFIER}.desktop
             DESTINATION  ${CMAKE_INSTALL_DATADIR}/applications
             )
-    install(FILES linux/com.github.quaternion.appdata.xml
+    install(FILES linux/${IDENTIFIER}.appdata.xml
             DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
             )
     install(FILES ${quaternion_QM}
@@ -189,35 +254,39 @@
                       )
 endif(LINUX)
 
+set(QML_DIR ${PROJECT_SOURCE_DIR}/client/qml)
+if (NOT DEPLOY_VERBOSITY)
+    set(DEPLOY_VERBOSITY 1) # The default for *deployqt tools, out of 0..3
+endif()
 if(WIN32)
-    if (${Qt5_VERSION} VERSION_LESS "5.3")
-        install(CODE "
-            message(\"Deploying on Windows is only supported with Qt 5.3 or higher\")
-            message(\"Bare executable has been copied to the target folder\")
-        ")
-    else()
-        get_filename_component(Qt5_WinBaseDir "${Qt5_DIR}/../../.." ABSOLUTE)
-        install(CODE "
-            if (CMAKE_INSTALL_CONFIG_NAME STREQUAL \"Debug\")
-                set(WDQ_FLAG debug)
-            else()
-                set(WDQ_FLAG release)
-            endif()
-            execute_process(
-                COMMAND bin/windeployqt --\${WDQ_FLAG} --no-system-d3d-compiler --no-opengl
-                    --no-multimedia --no-multimediaquick --no-declarative --no-test \
-                    --qmldir qml \"\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}\"
-                WORKING_DIRECTORY \"${Qt5_WinBaseDir}\"
-                RESULT_VARIABLE WDQ_RETVAL
-            )
-            if (WDQ_RETVAL)
-                message( \"windeployqt returned \${WDQ_RETVAL} - check messages above\")
-            else()
-                message( STATUS \"Quaternion and its dependencies have been deployed to \${CMAKE_INSTALL_PREFIX}.\")
-            endif()
-        ")
-        install(FILES ${quaternion_QM}
-                DESTINATION ${CMAKE_INSTALL_BINDIR}/translations
-               )
-    endif()
+    install(CODE "
+        message(STATUS \"Running windeployqt at \${CMAKE_INSTALL_PREFIX}\${CMAKE_INSTALL_BINDIR}\")
+        execute_process(
+            COMMAND \"${Qt5_BinDir}/windeployqt\" --verbose ${DEPLOY_VERBOSITY}
+                --no-multimediaquick --no-declarative --no-test --no-winextras
+                --qmldir \"${QML_DIR}\"
+                \${CMAKE_INSTALL_PREFIX}\${CMAKE_INSTALL_BINDIR}
+            RESULT_VARIABLE WDQ_RETVAL
+        )
+        if (WDQ_RETVAL)
+            message( \"windeployqt returned \${WDQ_RETVAL} - check messages above\")
+        else()
+            message( STATUS \"Quaternion and its dependencies have been deployed to \${CMAKE_INSTALL_PREFIX}.\")
+        endif()
+    ")
+    install(FILES ${quaternion_QM}
+            DESTINATION ${CMAKE_INSTALL_BINDIR}/translations
+           )
 endif(WIN32)
+
+# Packaging
+
+if(APPLE)
+    set(MACDEPLOYQT_ARGS ${PROJECT_NAME}.app -dmg -qmldir="${QML_DIR}" -verbose=${DEPLOY_VERBOSITY})
+    add_custom_target(image
+        COMMAND "${Qt5_BinDir}/macdeployqt" ${MACDEPLOYQT_ARGS}
+        DEPENDS ${PROJECT_NAME}
+        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
+        COMMENT "Running ${MACDEPLOYQT} with args: ${MACDEPLOYQT_ARGS}"
+    )
+endif(APPLE)

=== debian/changelog ===
quaternion (0.0.9.4c-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:24:08 +0100

quaternion (0.0.9.4c-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: build-depend on qt5keychain-dev

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 25 Jun 2019 21:59:11 -0400

=== debian/control ===
Source: quaternion
Section: net
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>
Build-Depends: cmake
 , debhelper (>=10)
 , libqmatrixclient-dev (>= 0.5.0)
 , qt5keychain-dev
 , qtbase5-dev
 , qtdeclarative5-dev
 , qtmultimedia5-dev
 , qttools5-dev
Standards-Version: 4.3.0
Homepage: https://github.com/quotient-im/Quaternion
Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
Vcs-Browser: https://salsa.debian.org/matrix-team/quaternion.git

Package: quaternion
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml-module-qtquick-controls, qml-module-qtquick-controls2
Description: desktop IM client for the Matrix protocol
 Quaternion is a Qt-based chat client for the Matrix protocol.  Matrix is an
 open, federated communications protocol.

## quaternion 0.0.9.4e

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
 
 set(IDENTIFIER "com.github.quaternion")
-set(COPYRIGHT "Copyright © 2018-2019 QMatrixClient Project")
+set(COPYRIGHT "Copyright © 2018-2020 QMatrixClient Project")
 
 project(quaternion VERSION 0.0.9.4 LANGUAGES CXX)

=== debian/changelog ===
quaternion (0.0.9.4e-1) unstable; urgency=medium

  * New upstream version.
  * Build with newer libqmatrixclient.

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 17 Apr 2020 22:25:00 -0400

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>
 Build-Depends: cmake
- , debhelper (>=10)
- , libqmatrixclient-dev (>= 0.5.0)
+ , debhelper-compat (=12)
+ , libqmatrixclient-dev (>= 0.5.3.2)
  , qt5keychain-dev
  , qtbase5-dev
  , qtdeclarative5-dev

## quaternion 0.0.9.5~beta2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,12 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
+if (POLICY CMP0092)
+cmake_policy(SET CMP0092 NEW)
+endif()
 
 set(IDENTIFIER "com.github.quaternion")
-set(COPYRIGHT "Copyright © 2018-2020 QMatrixClient Project")
-
-project(quaternion VERSION 0.0.9.4 LANGUAGES CXX)
+set(COPYRIGHT "Copyright © 2016-2018 QMatrixClient, 2019-2020 The Quotient Project")
+
+project(quaternion VERSION 0.0.9.5 LANGUAGES CXX)
 
 if(UNIX AND NOT APPLE)
     set(LINUX 1)
@@ -29,18 +32,23 @@
     "MinSizeRel" "RelWithDebInfo")
 endif()
 
-set(CMAKE_CXX_STANDARD 14)
-
 # Setup command line parameters for the compiler and linker
-foreach (FLAG "" all pedantic extra no-unused-parameter)
-    CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
-    if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W${FLAG}")
-    endif ()
-endforeach ()
+if (MSVC)
+    add_compile_options(/EHsc /W4
+        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
+        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
+        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027)
+else()
+    foreach (FLAG "" all pedantic extra no-unused-parameter)
+        CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
+        if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
+            add_compile_options(-W${FLAG})
+        endif ()
+    endforeach ()
+endif()
 
 # Find the libraries
-find_package(Qt5 5.7 REQUIRED Widgets Network Quick Qml Gui LinguistTools Multimedia DBus)
+find_package(Qt5 5.9 REQUIRED Widgets Network Quick Gui LinguistTools Multimedia DBus)
 # Qt5_Prefix is only used to show Qt path in message()
 # Qt5_BinDir is where all the binary tools for Qt are
 if (QT_QMAKE_EXECUTABLE)
@@ -51,7 +59,7 @@
     get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
 endif()
 if (USE_QQUICKWIDGET)
-    find_package(Qt5 5.7 REQUIRED QuickWidgets)
+    find_package(Qt5 5.9 REQUIRED QuickWidgets)
 elseif(NOT DISABLE_QQUICKWIDGET)
     # QQuickWidget only stopped crashing in Qt 5.12, use it by default if found
     find_package(Qt5 5.12 QUIET COMPONENTS QuickWidgets)
@@ -72,17 +80,17 @@
 
 if ((NOT DEFINED USE_INTREE_LIBQMC OR USE_INTREE_LIBQMC)
         AND EXISTS ${PROJECT_SOURCE_DIR}/lib/lib/util.h)
-    add_subdirectory(lib EXCLUDE_FROM_ALL)
+    add_subdirectory(lib)
     include_directories(lib)
     if (NOT DEFINED USE_INTREE_LIBQMC)
         set (USE_INTREE_LIBQMC 1)
     endif ()
 endif ()
 if (NOT USE_INTREE_LIBQMC)
-    find_package(QMatrixClient 0.5.1 REQUIRED)
-    if (NOT QMatrixClient_FOUND)
-        message( WARNING "libQMatrixClient not found; configuration will most likely fail.")
-        message( WARNING "Make sure you have installed libQMatrixClient development files")
+    find_package(Quotient 0.6 REQUIRED)
+    if (NOT Quotient_FOUND)
+        message( WARNING "libQuotient not found; configuration will most likely fail.")
+        message( WARNING "Make sure you have installed libQuotient development files")
         message( WARNING "as a package or checked out the library sources in lib/.")
         message( WARNING "See also BUILDING.md")
     endif ()
@@ -114,7 +122,7 @@
 message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
 message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
 if (USE_INTREE_LIBQMC)
-    message( STATUS "Using in-tree libQMatrixClient")
+    message( STATUS "Using in-tree libQuotient")
     if (GIT_FOUND)
         execute_process(COMMAND
             "${GIT_EXECUTABLE}" rev-parse -q HEAD
@@ -124,20 +132,22 @@
         message( STATUS "  Library git SHA1: ${LIB_GIT_SHA1}")
     endif (GIT_FOUND)
 else ()
-    message( STATUS "Using libQMatrixClient ${QMatrixClient_VERSION} at ${QMatrixClient_DIR}")
+    message( STATUS "Using libQuotient ${Quotient_VERSION} at ${Quotient_DIR}")
 endif ()
 if (USE_QQUICKWIDGET)
     message( STATUS "Using QQuickWidget to render QML")
 endif(USE_QQUICKWIDGET)
 if (USE_KEYCHAIN)
-    message( STATUS "Using Qt5Keychain ${Qt5Keychain_VERSION} at ${Qt5Keychain_DIR}")
+    message( STATUS "Using Qt Keychain ${Qt5Keychain_VERSION} at ${Qt5Keychain_DIR}")
 endif ()
 message( STATUS "=============================================================================" )
 message( STATUS )
 
 # Set up source files
 set(quaternion_SRCS
+    client/accountregistry.cpp
     client/quaternionroom.cpp
+    client/htmlfilter.cpp
     client/imageprovider.cpp
     client/activitydetector.cpp
     client/dialog.cpp
@@ -147,10 +157,12 @@
     client/mainwindow.cpp
     client/roomlistdock.cpp
     client/userlistdock.cpp
+    client/accountselector.cpp
     client/kchatedit.cpp
     client/chatedit.cpp
     client/chatroomwidget.cpp
     client/systemtrayicon.cpp
+    client/profiledialog.cpp
     client/models/messageeventmodel.cpp
     client/models/userlistmodel.cpp
     client/models/roomlistmodel.cpp
@@ -172,9 +184,10 @@
 
 set(quaternion_TS
     client/translations/quaternion_en_GB.ts
-    client/translations/quaternion_de_DE.ts
+    client/translations/quaternion_de.ts
     client/translations/quaternion_pl.ts
     client/translations/quaternion_ru.ts
+    client/translations/quaternion_es.ts
     )
 QT5_ADD_TRANSLATION(quaternion_QM ${quaternion_TS})
 
@@ -209,10 +222,17 @@
     ${quaternion_SRCS} ${quaternion_QRC_SRC} ${quaternion_QM}
     ${quaternion_WINRC} ${${PROJECT_NAME}_MAC_ICON})
 
-target_link_libraries(${PROJECT_NAME}
-    QMatrixClient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)
+target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_17)
+
 target_compile_definitions(${PROJECT_NAME} PRIVATE
     GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")
+target_compile_definitions(${PROJECT_NAME} PRIVATE QT_NO_JAVA_STYLE_ITERATORS)
+if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.16.0"
+        AND NOT CMAKE_CXX_COMPILER_ID STREQUAL GNU) # https://bugzilla.redhat.com/show_bug.cgi?id=1721553
+    target_precompile_headers(${PROJECT_NAME} PRIVATE <lib/room.h>)
+endif ()
+target_link_libraries(${PROJECT_NAME}
+    Quotient Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network)
 
 if (USE_QQUICKWIDGET)
     target_compile_definitions(${PROJECT_NAME} PRIVATE USE_QQUICKWIDGET)
@@ -226,8 +246,10 @@
 endif()
 
 # macOS specific config for bundling
-set_property(TARGET ${PROJECT_NAME} PROPERTY
-    MACOSX_BUNDLE_INFO_PLIST "${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in")
+if (APPLE)
+    set_property(TARGET ${PROJECT_NAME} PROPERTY MACOSX_BUNDLE_INFO_PLIST
+                 "${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in")
+endif()
 
 # Installation
 
@@ -246,7 +268,7 @@
             DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
             )
     install(FILES ${quaternion_QM}
-            DESTINATION ${CMAKE_INSTALL_DATADIR}/QMatrixClient/quaternion/translations
+            DESTINATION ${CMAKE_INSTALL_DATADIR}/Quotient/quaternion/translations
             )
     file(GLOB quaternion_icons icons/quaternion/*-apps-quaternion.png)
     ecm_install_icons(ICONS ${quaternion_icons} icons/quaternion/sc-apps-quaternion.svgz

=== debian/changelog ===
quaternion (0.0.9.5~beta2-2) unstable; urgency=medium

  * Add upstream patches to fix crashes and rendering issues.  (Closes: #983707)

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 01 Mar 2021 16:46:15 -0500

quaternion (0.0.9.5~beta2-1) unstable; urgency=medium

  * New upstream beta.
  * Build with libquotient instead of libqmatrixclient. (Closes: #980651)

 -- Hubert Chathi <uhoreg@debian.org>  Fri, 22 Jan 2021 17:16:02 -0500

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Hubert Chathi <uhoreg@debian.org>
 Build-Depends: cmake
  , debhelper-compat (=12)
- , libqmatrixclient-dev (>= 0.5.3.2)
+ , libquotient-dev (>= 0.6.4)
  , qt5keychain-dev
  , qtbase5-dev
  , qtdeclarative5-dev
  , qtmultimedia5-dev
  , qttools5-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/quotient-im/Quaternion
 Vcs-Git: https://salsa.debian.org/matrix-team/quaternion.git
 Vcs-Browser: https://salsa.debian.org/matrix-team/quaternion.git
